/**
 * Copyright (c) 2015-2016, NVIDIA CORPORATION.  All rights reserved.
 *
 * NVIDIA Corporation and its licensors retain all intellectual property
 * and proprietary rights in and to this software, related documentation
 * and any modifications thereto.  Any use, reproduction, disclosure or
 * distribution of this software and related documentation without an express
 * license agreement from NVIDIA Corporation is strictly prohibited.
 *
 */

#ifndef GST_NVIVA_META_API_H
#define GST_NVIVA_META_API_H

#include <gst/gst.h>
#include <gst/video/video.h>
#include <gst/base/gstbasetransform.h>

GType iva_meta_api_get_type (void);
#define IVA_META_API_TYPE (iva_meta_api_get_type())

const GstMetaInfo *iva_meta_get_info (void);
#define IVA_META_INFO (iva_meta_get_info())

typedef struct _IvaMeta IvaMeta;

struct _IvaMeta {
  GstMeta       meta;
  void *meta_data;
  GDestroyNotify destroy;
};

IvaMeta *gst_buffer_add_iva_meta (GstBuffer *buffer, void *meta_data);

IvaMeta *gst_buffer_add_iva_meta_full (GstBuffer *buffer, void *meta_data,
        GDestroyNotify destroy);
IvaMeta *gst_buffer_get_iva_meta (GstBuffer *buffer);
#endif
